## START: Set by rpmautospec
## (rpmautospec version 0.6.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

Name:           keepass
Version:        2.57
Release:        %autorelease
Summary:        Password manager

License:        GPL-2.0-or-later
URL:            https://keepass.info/

Source0:        https://downloads.sourceforge.net/project/%{name}/KeePass%202.x/%{version}/KeePass-%{version}-Source.zip
Source1:        https://keepass.info/integrity/v2/KeePass-%{version}-Source.zip.asc
Source2:        https://keepass.info/integrity/DominikReichl.asc
Source3:        %{name}.appdata.xml

# Upstream does not include a .desktop file, etc..
Patch0:         keepass-desktop-integration.patch

# Move XSL files to /usr/share/keepass:
Patch1:         keepass-fix-XSL-search-path.patch

ExclusiveArch:  %{mono_arches}
ExcludeArch:    armv7hl
BuildRequires:  ImageMagick
BuildRequires:  desktop-file-utils
BuildRequires:  gnupg2
BuildRequires:  libappstream-glib
BuildRequires:  libgdiplus-devel
BuildRequires:  mono-devel
BuildRequires:  mono-winforms
BuildRequires:  mono-web
BuildRequires:  xorg-x11-server-Xvfb
Requires:       xdotool xsel hicolor-icon-theme
Requires:       mono-winforms
Recommends:     libargon2
%if 0%{?fedora} >=24 || 0%{?rhel} >= 8
Recommends:     libgcrypt
%endif


# The debuginfo package would be empty if created.
%global debug_package %{nil}


%description
KeePass is a free open source password manager, which helps you to
remember your passwords in a secure way. You can put all your passwords in
one database, which is locked with one master key or a key file.  You
only have to remember one single master password or select the key file
to unlock the whole database.


%prep
%{gpgverify}                \
  --keyring='%{SOURCE2}'    \
  --signature='%{SOURCE1}'  \
  --data='%{SOURCE0}'

%autosetup -p1 -c

# use /app prefix in flatpak builds
%if 0%{?flatpak}
sed -i -e 's|/usr|%{_prefix}|g' dist/%{name} KeePass/App/AppDefs.cs
%endif

# Make sure no prebuilt dlls are shipped
find -name "*dll" -delete

# Work around libpng bug (https://bugzilla.redhat.com/show_bug.cgi?id=1276843):
find -name \*.png -print0 | xargs -0 mogrify -define png:format=png32


%build
( cd Build && sh PrepMonoDev.sh )
find . -name "*.sln" -print -exec sed -i 's/Format Version 10.00/Format Version 11.00/g' {} \;
xbuild /target:KeePass /property:TargetFrameworkVersion=v$(ls -d %{_monodir}/*-api | cut -d/ -f5 | cut -d- -f1 | sort -Vr | head -1) /property:Configuration=Release
for subdir in Images_App_HighRes Images_Client_16 Images_Client_HighRes; do
    xvfb-run -a mono Build/KeePass/Release/KeePass.exe -d:`pwd`/Ext/$subdir --makexspfile `pwd`/KeePass/Resources/Data/$subdir.bin
done
xbuild /target:KeePass /property:TargetFrameworkVersion=v$(ls -d %{_monodir}/*-api | cut -d/ -f5 | cut -d- -f1 | sort -Vr | head -1) /property:Configuration=Release

%install
install -d %{buildroot}/%{_prefix}/lib/%{name} %{buildroot}/%{_prefix}/lib/%{name}/Languages %{buildroot}/%{_datadir}/%{name} %{buildroot}/%{_datadir}/%{name}/XSL %{buildroot}/%{_datadir}/applications %{buildroot}/%{_bindir} %{buildroot}/%{_datadir}/mime/packages %{buildroot}/%{_datadir}/icons/hicolor/512x512/apps %{buildroot}/%{_datadir}/icons/hicolor/256x256/apps %{buildroot}/%{_datadir}/icons/hicolor/128x128/apps %{buildroot}/%{_datadir}/icons/hicolor/64x64/apps %{buildroot}/%{_datadir}/icons/hicolor/48x48/apps %{buildroot}/%{_datadir}/icons/hicolor/32x32/apps %{buildroot}/%{_datadir}/icons/hicolor/16x16/apps %{buildroot}/%{_mandir}/man1 %{buildroot}/%{_docdir}/%{name} %{buildroot}/%{_datadir}/appdata
install -p -m 0644 Build/KeePass/Release/KeePass.exe Ext/KeePass.config.xml Ext/KeePass.exe.config %{buildroot}/%{_prefix}/lib/%{name}
install -p -m 0644 Ext/XSL/KDBX_Common.xsl Ext/XSL/KDBX_DetailsFull_HTML.xsl Ext/XSL/KDBX_DetailsLight_HTML.xsl Ext/XSL/KDBX_PasswordsOnly_TXT.xsl Ext/XSL/KDBX_Tabular_HTML.xsl %{buildroot}/%{_datadir}/%{name}/XSL
install -p -m 0644 -T Ext/Icons_15_VA/KeePass_Round/KeePass_Round_512.png %{buildroot}/%{_datadir}/icons/hicolor/512x512/apps/%{name}.png
install -p -m 0644 -T Ext/Icons_15_VA/KeePass_Round/KeePass_Round_256.png %{buildroot}/%{_datadir}/icons/hicolor/256x256/apps/%{name}.png
install -p -m 0644 -T Ext/Icons_15_VA/KeePass_Round/KeePass_Round_128.png %{buildroot}/%{_datadir}/icons/hicolor/128x128/apps/%{name}.png
install -p -m 0644 -T Ext/Icons_15_VA/KeePass_Round/KeePass_Round_64.png %{buildroot}/%{_datadir}/icons/hicolor/64x64/apps/%{name}.png
install -p -m 0644 -T Ext/Icons_15_VA/KeePass_Round/KeePass_Round_48.png %{buildroot}/%{_datadir}/icons/hicolor/48x48/apps/%{name}.png
install -p -m 0644 -T Ext/Icons_15_VA/KeePass_Round/KeePass_Round_32.png %{buildroot}/%{_datadir}/icons/hicolor/32x32/apps/%{name}.png
install -p -m 0644 -T Ext/Icons_15_VA/KeePass_Round/KeePass_Round_16.png %{buildroot}/%{_datadir}/icons/hicolor/16x16/apps/%{name}.png
desktop-file-install --dir=%{buildroot}/%{_datadir}/applications dist/%{name}.desktop
install -p -m 0644 dist/%{name}.xml %{buildroot}/%{_datadir}/mime/packages
install -p -m 0644 dist/%{name}.1 %{buildroot}/%{_mandir}/man1
install -p -m 0644 %{SOURCE3} %{buildroot}/%{_datadir}/appdata
install -p dist/%{name} %{buildroot}/%{_bindir}
sed 's/\r$//' Docs/History.txt > %{buildroot}/%{_docdir}/%{name}/History.txt
sed 's/\r$//' Docs/License.txt > %{buildroot}/%{_docdir}/%{name}/License.txt


%check
desktop-file-validate %{buildroot}%{_datadir}/applications/*.desktop
appstream-util validate-relax --nonet %{buildroot}/%{_datadir}/appdata/*.appdata.xml


%files
%doc %{_docdir}/%{name}/History.txt
%license %{_docdir}/%{name}/License.txt
%{_bindir}/%{name}
%{_prefix}/lib/%{name}
%{_datadir}/%{name}
%{_datadir}/applications/%{name}.desktop
%{_datadir}/mime/packages/%{name}.xml
%{_datadir}/icons/hicolor/512x512/apps/%{name}.png
%{_datadir}/icons/hicolor/256x256/apps/%{name}.png
%{_datadir}/icons/hicolor/128x128/apps/%{name}.png
%{_datadir}/icons/hicolor/64x64/apps/%{name}.png
%{_datadir}/icons/hicolor/48x48/apps/%{name}.png
%{_datadir}/icons/hicolor/32x32/apps/%{name}.png
%{_datadir}/icons/hicolor/16x16/apps/%{name}.png
%{_mandir}/man1/%{name}.1*
%{_datadir}/appdata/%{name}.appdata.xml


%changelog
## START: Generated by rpmautospec
* Sun Jun 02 2024 Julian Sikorski <belegdol@fedoraproject.org> - 2.57-1
- Update to version 2.57

* Sun Feb 04 2024 Julian Sikorski <belegdol@fedoraproject.org> - 2.56-1
- Update to version 2.56.

* Wed Jan 24 2024 Fedora Release Engineering <releng@fedoraproject.org> - 2.55-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Sun Jan 21 2024 Fedora Release Engineering <releng@fedoraproject.org> - 2.55-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Wed Jan 17 2024 Yaakov Selkowitz <yselkowi@redhat.com> - 2.55-6
- Fix flatpak build

* Tue Jan 02 2024 Julian Sikorski <belegdol@fedoraproject.org> - 2.55-5
- Fix missing sources

* Fri Dec 01 2023 Julian Sikorski <belegdol@fedoraproject.org> - 2.55-4
- Fix build error

* Fri Dec 01 2023 Julian Sikorski <belegdol@fedoraproject.org> - 2.55-3
- Use upstream source archive directly and verify it during %%%%prep

* Tue Nov 21 2023 Julian Sikorski <belegdol@fedoraproject.org> - 2.55-2
- Cleanup for upcoming re-review
- Do not own %%%%docdir
- Flag license file as %%%%license
- Migrate to SPDX license

* Tue Nov 21 2023 Julian Sikorski <belegdol@fedoraproject.org> - 2.55-1
- Update to version 2.55.

* Tue Nov 21 2023 Julian Sikorski <belegdol@fedoraproject.org> - 2.54-1
- Update to version 2.54.

* Tue Nov 21 2023 Julian Sikorski <belegdol@fedoraproject.org> - 2.53.1-2
- Disable xdotool clipboard workaround to prevent passwords from leaking to
  systemd journal (CVE-2022-0725)

* Tue Nov 21 2023 Julian Sikorski <belegdol@fedoraproject.org> - 2.53.1-1
- Update to version 2.53.1.

* Tue Nov 21 2023 Julian Sikorski <belegdol@fedoraproject.org> - 2.52-1
- Update to version 2.52.

* Tue Nov 21 2023 Julian Sikorski <belegdol@fedoraproject.org> - 2.51.1-1
- Update to version 2.51.1.

* Tue Nov 21 2023 Julian Sikorski <belegdol@fedoraproject.org> - 2.50-2
- Revert "Don't know how to fix CVE-2022-0725."

* Sat Jan 22 2022 Peter Oliver <git@mavit.org.uk> - 2.50-1
- Update to version 2.50.

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 2.49-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Sun Sep 19 2021 Peter Oliver <git@mavit.org.uk> - 2.49-1
- Update to version 2.49.

* Thu Jul 22 2021 Fedora Release Engineering <releng@fedoraproject.org> - 2.48.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Tue May 18 2021 Peter Oliver <git@mavit.org.uk> - 2.48.1-2
- Create directory /usr/lib/keepass/Languages

* Tue May 11 2021 Peter Oliver <git@mavit.org.uk> - 2.48.1-1
- Update to version 2.48.1.

* Fri May 07 2021 Peter Oliver <git@mavit.org.uk> - 2.48-1
- Update to version 2.48.

* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 2.47-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Sat Jan 09 2021 Peter Oliver <git@mavit.org.uk> - 2.47-1
- Update to version 2.47.

* Thu Sep 17 2020 Peter Oliver <git@mavit.org.uk> - 2.46-2
- Exclude from armv7hl, where this doesn't currently build.

* Fri Sep 11 2020 Peter Oliver <git@mavit.org.uk> - 2.46-1
- Update to version 2.46.

* Tue Jul 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 2.45-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Thu Jul 02 2020 Peter Oliver <git@mavit.org.uk> - 2.45-2
- Drop Recommends on gtk2

* Sat May 09 2020 Peter Oliver <git@mavit.org.uk> - 2.45-1
- Update to version 2.45.

* Wed Jan 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 2.44-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Sat Jan 25 2020 Peter Oliver <git@mavit.org.uk> - 2.44-1
- Update to version 2.44.

* Sun Sep 15 2019 Peter Oliver <git@mavit.org.uk> - 2.43-1
- Update to version 2.43.

* Thu Jul 25 2019 Fedora Release Engineering <releng@fedoraproject.org> - 2.42.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Tue Jun 25 2019 Peter Oliver <git@mavit.org.uk> - 2.42.1-4
- Use Recommends header only where available.

* Tue Jun 25 2019 Peter Oliver <git@mavit.org.uk> - 2.42.1-3
- Drop unused file keepass-enable-local-help.patch.

* Tue May 07 2019 Peter Oliver <git@mavit.org.uk> - 2.42.1-2
- Always build against latest available Mono framework version.

* Tue May 07 2019 Peter Oliver <git@mavit.org.uk> - 2.42.1-1
- Update to version 2.42.1.

* Wed May 01 2019 Peter Oliver <git@mavit.org.uk> - 2.42-1
- Update to version 2.42.

* Sun Apr 28 2019 Peter Oliver <git@mavit.org.uk> - 2.41-4
- Require mono-winforms.

* Sun Apr 28 2019 Peter Oliver <git@mavit.org.uk> - 2.41-3
- Build against against framework version 4.7.1 for Mono 5.18.  Fixes
  #1680388.

* Fri Feb 01 2019 Fedora Release Engineering <releng@fedoraproject.org> - 2.41-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Sun Jan 13 2019 Peter Oliver <git@mavit.org.uk> - 2.41-1
- Update to version 2.41.

* Sat Sep 22 2018 Peter Oliver <git@mavit.org.uk> - 2.40-1
- Update to version 2.40

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.39.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Sun May 13 2018 Peter Oliver <git@mavit.org.uk> - 2.39.1-1
- Update to version 2.39.1.

* Tue May 08 2018 Peter Oliver <git@mavit.org.uk> - 2.39-2
- Suggest documentation.

* Tue May 08 2018 Peter Oliver <git@mavit.org.uk> - 2.39-1
- Update to version 2.39.

* Tue Mar 27 2018 Peter Oliver <git@mavit.org.uk> - 2.38-8
- Bump revision.

* Mon Mar 19 2018 Vasiliy Glazov <vascom2@gmail.com> - 2.38-7
- Correct directory owning

* Thu Mar 15 2018 Iryna Shcherbina <shcherbina.iryna@gmail.com> - 2.38-6
- Update Python 2 dependency declarations to new packaging standards

* Fri Feb 09 2018 Igor Gnatenko <ignatenkobrain@fedoraproject.org> - 2.38-5
- Escape macros in %%changelog

* Wed Feb 07 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.38-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Tue Feb 06 2018 Peter Oliver <git@mavit.org.uk> - 2.38-3
- Update URL.

* Wed Jan 31 2018 Peter Oliver <git@mavit.org.uk> - 2.38-2
- Remove icon cache scriptlets, to keep up with latest packaging
  guidelines.

* Wed Jan 10 2018 Peter Oliver <git@mavit.org.uk> - 2.38-1
- Update to version 2.38.

* Sat Oct 14 2017 Peter Oliver <git@mavit.org.uk> - 2.37-2
- Recommend gtk2 and libgcrypt packages

* Sat Oct 14 2017 Peter Oliver <git@mavit.org.uk> - 2.37-1
- Update to version 2.37.

* Thu Aug 03 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.36-3
- Rebuilt for
  https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.36-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Mon Jun 12 2017 Peter Oliver <git@mavit.org.uk> - 2.36-1
- Update to version 2.36.

* Tue Feb 21 2017 Peter Oliver <git@mavit.org.uk> - 2.35-4
- Remember to bump release number.

* Tue Feb 21 2017 Peter Oliver <git@mavit.org.uk> - 2.35-3
- Workaround for crash when pressing Super key.  Fixes #1424852.

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.35-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Fri Jan 20 2017 Peter Oliver <git@mavit.org.uk> - 2.35-1
- Update to 2.35.

* Fri Jan 20 2017 Peter Oliver <git@mavit.org.uk> - 2.34-8
- Validate appdata.

* Thu Oct 13 2016 Peter Robinson <pbrobinson@gmail.com> - 2.34-7
- mono rebuild for aarch64 support

* Sun Aug 28 2016 Peter Oliver <git@mavit.org.uk> - 2.34-6
- Fix bad rebase.

* Sun Aug 28 2016 Peter Oliver <git@mavit.org.uk>
- Update to version 2.34.

* Mon Aug 22 2016 Peter Oliver <git@mavit.org.uk> - 2.33-4
- Remove scriptlets replaced by triggers in Fedora 25.

* Mon Aug 22 2016 Peter Oliver <git@mavit.org.uk> - 2.33-3
- Remove scriptlets replaced by triggers in Fedora 24.

* Mon Aug 22 2016 Peter Oliver <git@mavit.org.uk> - 2.33-2
- Update AppStream XML.

* Sat May 21 2016 Peter Oliver <git@mavit.org.uk> - 2.33-1
- Update to version 2.33.

* Sat May 21 2016 Peter Oliver <git@mavit.org.uk> - 2.32-3
- Remove now-unneeded workaround for BOM-handling bug in grep.

* Fri Mar 11 2016 Peter Oliver <git@mavit.org.uk> - 2.32-2
- Add link to BOM-handling bug.

* Thu Mar 10 2016 Peter Oliver <git@mavit.org.uk> - 2.32-1
- Update to version 2.32.

* Thu Feb 04 2016 Dennis Gilmore <dennis@ausil.us> - 2.31-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Mon Jan 11 2016 Peter Oliver <git@mavit.org.uk> - 2.31-1
- Update to version 2.31.

* Sun Jan 10 2016 Peter Oliver <git@mavit.org.uk> - 2.30-8
- Add keyword to .desktop file.

* Tue Jan 05 2016 Peter Oliver <git@mavit.org.uk> - 2.30-7
- Remove workaround for #1251756, which is now fixed.

* Sun Nov 22 2015 Peter Oliver <git@mavit.org.uk> - 2.30-6
- Work around some icons not appearing in 2.30.  Fixes #1276843.

* Sun Nov 22 2015 Peter Oliver <git@mavit.org.uk> - 2.30-5
- Ensure .png files are repacked into .bin files at build time.

* Fri Oct 23 2015 Peter Oliver <git@mavit.org.uk> - 2.30-4
- Set StartupWMClass.  Fixes #1266312.

* Sun Aug 09 2015 Peter Oliver <git@mavit.org.uk> - 2.30-3
- Inline comments not possible.

* Sun Aug 09 2015 Peter Oliver <git@mavit.org.uk>
- Add workaround for #1251756.

* Sun Aug 09 2015 Peter Oliver <git@mavit.org.uk> - 2.30-1
- Update to 2.30.  Fixes #1222120.

* Wed Jun 17 2015 Dennis Gilmore <dennis@ausil.us> - 2.29-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Tue May 19 2015 Peter Robinson <pbrobinson@gmail.com> - 2.29-1
- 2.29 plus mono 4 build fixes

* Mon May 18 2015 Peter Robinson <pbrobinson@gmail.com> - 2.27-5
- Rebuild (mono4)

* Sat Oct 04 2014 Dan Horák <dan@danny.cz> - 2.27-4
- switch to ExclusiveArch, but seems FTBFS even on x86_64

* Mon Aug 18 2014 Rex Dieter <rdieter@math.unl.edu> - 2.27-3
- update mime scriptlets

* Sat Aug 16 2014 Peter Robinson <pbrobinson@fedoraproject.org> - 2.27-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Fri Jul 18 2014 Peter Oliver <git@mavit.org.uk> - 2.27-1
- Update to version 2.27.

* Fri Jul 18 2014 Peter Oliver <git@mavit.org.uk> - 2.26-10
- Add missing %%u to Exec line in .desktop.

* Sun Jun 08 2014 Dennis Gilmore <dennis@ausil.us> - 2.26-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Fri May 23 2014 Peter Oliver <git@mavit.org.uk> - 2.26-8
- Bump version number.

* Thu May 22 2014 Peter Oliver <git@mavit.org.uk> - 2.26-7
- Mono crashes on ARM builders, so exclude that architecture.

* Thu May 22 2014 Peter Oliver <git@mavit.org.uk> - 2.26-6
- The "%%{__python2}" macro requires python-devel.

* Thu May 22 2014 Peter Oliver <git@mavit.org.uk> - 2.26-5
- Depend on hicolor-icon-theme.

* Thu May 22 2014 Peter Oliver <git@mavit.org.uk> - 2.26-4
- Use "%%{__python2}" macro.

* Thu May 22 2014 Peter Oliver <git@mavit.org.uk> - 2.26-3
- Use "doc" rather than "-n %%{name}-doc" in subpackages.

* Thu May 22 2014 Peter Oliver <git@mavit.org.uk> - 2.26-2
- Use "*" rather than ".gz" as the man page suffix, in case the compression
  format changes.

* Thu May 22 2014 Peter Oliver <git@mavit.org.uk> - 2.26-1
- Initial import.  Bug 1089425.
## END: Generated by rpmautospec
